on *:signal:upd8*:{
  .sockclose $signal
  sockopen $signal $1-2
  sockmark $signal $1 $3-5
}
alias rem_upd8 {
  var %rm = $numtok(%version,32), %ri = 1
  while (%ri <= %rm) {
    if ($hget(version)) hdel version $gettok(%version,%ri,32)
    inc %ri
  }
  unset %version
}
alias d_upd8 {
  rem_upd8
  unset %dx*
  if ($hget(soulfly,upd8x)) {
    if ($hget(version,1).item) {
      var %v_0 = $hget(version,0).item
      while (%v_0) {
        if ($regex($hget(version,%v_0).item,/sfb_alias.ini|sfb_conn.mrc|menu_1.ini/)) {
          hfree version
          unset %version
          echo -s 3,9 SoulFly Update  Updates are available.
          return
        }
        dec %v_0
      }
      hfree version
      unset %version
      echo -s 3,9 SoulFly Update  Addons are available.
    }
    else {
      if ($hget(version)) hfree version
      hdel soulfly upd8x
      unset %version
    }
  }
  else dialog $iif($dialog(update),-v,-mh) update update
}
on *:unload:remini soulfly.ini version $nopath($script)
on *:start:{
  writeini soulfly.ini version $nopath($script) 1.5x3
  upd8_chk
  if ($dialog(upd8r)) dialog -x upd8r upd8r
  if ($dialog(update)) dialog -x update update
}
on *:sockclose:upd8*:{
  if ($gettok($sock($sockname).mark,1,32) = TRUE) {
    var %upd8_2 = $gettok($sock($sockname).mark,2,32)
    if ($dialog(upd8r)) did -ra upd8r 2 $nopath(%upd8_2) Install Complete
    if ($dialog(update)) { did -r update 4,5 | did -ra update 4 $nopath(%upd8_2) Install Complete }
    .timerupd8r 1 1 /upd8r_x
    .load $iif(%dxalias,-a,-rs) $qt(%upd8_2)
    hadd soulfly upd8 $true
    if ($nopath(%upd8_2) = sfb_alias.ini) upd8_sfb_conn
    if (%dx_upd8 >= 1) dx_upd8
    .unset %dxalias %dx-mark
    if ($hget(version)) {
      hdel version $nopath(%upd8_2)
      hdel version $+(p_,$nopath(%upd8_2))
      hdel version $+(d_,$nopath(%upd8_2))
    }
    d_1
  }
}
alias upd8_chk {
  var %upd8_u = $script(0), %upd8_scx, %upd8_sc
  while (%upd8_u) {
    if (upd8* iswm $nopath($script(%upd8_u))) {
      if (%upd8_scx = 1) {
        %upd8_sc = $qt($script(%upd8_u))
        .unload -rs %upd8_sc | .remove %upd8_sc | break
      }
      inc %upd8_scx
    }
    dec %upd8_u
  }
}
alias upd8r_x {
  if ($dialog(upd8r)) dialog -x upd8r upd8r
}
dialog update {
  title "Update"
  size 465 465 194 104
  option dbu
  icon imgs\1x.ico
  list 1, 2 24 70 67, extsel size
  button "Update", 2, 2 92 34 12
  button "Refresh", 6, 38 92 34 12
  text "", 3, 1 13 72 10, center
  text "", 4, 72 93 116 10, right
  text "Select a file to view the description.", 5, 83 30 105 56
  box "Description", 7, 76 20 115 72
  text "", 100, 0 0 116 10
  icon 101, 80 -4 144 18, imgs\sf1.jpg, 0, noborder
  text "", 102, 188 0 6 10
  button "close", 84, 2 -2 27 13
}
on *:dialog:update:init:*:{
  mdx_head
  xmdx SetDialog update bgcolor $rgb(255,255,255)
  xmdx SetControlMDX update 1 ListView list noheader report single sortdescending checkboxes rowselect labeltip > dlls\views.mdx
  xmdx SetColor update 1,3,4,5,7 background $rgb(255,255,255)
  xmdx SetColor update 3,4,5,7 textbg $rgb(255,255,255)
  xmdx SetFont update 3,4,5,7 20 500 Sylfaen
  xmdx SetFont update 1 18 500 Sylfaen
  xmdx SetFont update 2,6 18 600 Sylfaen
  xmdx SetFont update 84 24 500 Trebuchet MS Bold
  xmdx SetColor update 100,102 background $rgb(224,223,228)
  d_1
}
alias d_1 {
  if ($hget(version)) {
    did -r update 1
    var %rx = $hget(version,0).item, %r = 1
    while (%r <= %rx) {
      if (d_* iswm $hget(version,%r).item) || (p_* iswm $hget(version,%r).item) { inc %r | continue }
      did -ca update 1 $hget(version,%r).item
      inc %r
      if (%r > %rx) did -c update 1 1
    }
  }
  did -ra update 3 $iif($did(update,1).lines != 1,$calc($ifmatch - 1),No) $iif($ifmatch = 2,Update,Updates) Available
}
on *:sockread:upd8*:{
  if ($sockerr > 0) return
  var %xx
  sockread %xx | tokenize 32 %xx
  if ($gettok($sock($sockname).mark,1,32) = TRUE) {
    if ($1 = Content-Length:) && ($dialog(update)) {
      upd8r
      did -ra upd8r 2 Installing $nopath($gettok($sock($sockname).mark,2,32))
      did -a upd8r 1 1 1 $2
      set %dx-mark $true
    }
    else {
      if (%dx-mark) {
        if ($dialog(upd8r)) did -a upd8r 1 DELTA $sockbr
        if ($1 = [aliases]) set %dxalias $true
        inc -u4 %hadd
        write $qt($gettok($sock($sockname).mark,2,32)) $1-
      }
    }
  }
  else {
    if (update start = $1-) set %dx 0
    if (updat* !iswm $1-) && (%dx != $null) {
      if ($left($1,2) = p_) || ($left($1,2) = d_) hadd version $1 $2-
      else {
        inc %dx
        if ($left($1,2) != p_) {
          set %dx_ [ $+ [ $1 ] ] $2
          %version = $remtok(%version,$1,1,32)
        }
      }
    }
    if ($1- = Update End) {
      var %v_i = 1, %v = $var(dx_*,0)
      while (%v_i <= %v) {
        if (*mark* iswm $1-) {
          inc %v_i
          if (%v_i > %v) d_upd8
          else continue
        }
        var %vx = $remove($var(dx_*,%v_i),$chr(37),dx_), %vv = $var(dx_*,%v_i).value
        if (!$hget(version,%vx)) || ($hget(version,%vx) < %vv) {
          hadd version %vx %vv
          inc %v_i
          if (%v_i > %v) { d_upd8 | break }
          else continue
        }
        if ($hget(version,%vx) >= %vv) {
          hdel version p_ $+ %vx
          hdel version %vx
          hdel version d_ $+ %vx
          inc %v_i
          if (%v_i > %v) d_upd8
          else continue
        }
      }
    }
  }
}

on *:dialog:upd8r:init:*:{
  mdx_head
  xmdx SetControlMDX upd8r 1 ProgressBar smooth > dlls\ctl_gen.mdx
  xmdx SetFont upd8r 2 17 500 Arial
}
on *:dialog:update:sclick:*:{
  if ($did = 1) {
    if ($did(1).sel = 0) || ($left($did(1).sel,1) = -) return
    did -ra update 5 $hget(version,d_ $+ $gettok($did(1).seltext,6,32))
  }
  elseif ($did = 6) updateme
  elseif ($did = 2) {
    var %u = $did(1).lines, %u_i = 2
    while (%u_i <= %u) {
      if ($gettok($did(1,%u_i),5,32) = 2) %dx_upd8 [ $+ [ %u_i ] ] = $gettok($did(1,%u_i),6-,32)
      inc %u_i
      if (%u_i > %u) {
        if (!$var(dx_upd8*,0)) did -ra update 4 Please Select An Update
        else { set %dx_upd8 $var(dx_upd8*,0) | dx_upd8 }
      }
    }
  }
  elseif ($did = 84) {
    unset %dx*
    if ($hget(version)) hfree version
    dialog -x update update
  }
}
alias dx_upd8 {
  .signal $+(upd8,%dx_upd8) www.washington-tech.com 80 $var(dx_upd8*,%dx_upd8).value TRUE
  did -ra update 4 Downloading $var(dx_upd8*,%dx_upd8).value
  dec %dx_upd8
  if (%dx_upd8 = 0) unset %dx_upd8*
}
on *:sockopen:upd8*:{
  if ($sockerr > 0) return
  var %upd8_m = $gettok($sock($sockname).mark,1,32), %upd8_h = $gettok($sock($sockname).mark,2,32), %upd8_p
  if ($gettok($sock($sockname).mark,3,32) = TRUE) {
    sockmark $sockname TRUE $hget(version,$+(p_,%upd8_h))
    if ($dialog(upd8r)) did -ra upd8r 2 Downloading %upd8_h)
    %upd8_p = $gettok($sock($sockname).mark,2,32)
    if ($nofile(%upd8_p) != $null) && (!$isdir($v1)) mkdir $qt($nofile(%upd8_p))
    if ($file(%upd8_p).shortfn) && (upd8* !iswm $ifmatch) write -c $qt($file(%upd8_p).shortfn)
    sockwrite -n $sockname GET $+(/Buzzen/Update/,%upd8_h) $+(HTTP/1.0,$crlf,User-Agent: WaTech,$crlf,Accept:) $+(*/*,$crlf,Host:) %upd8_m
    sockwrite -n $sockname $crlf
    sockwrite -n $sockname Connection: Close
  }
  else {
    sockmark $sockname %upd8_h
    sockwrite -n $sockname GET /Buzzen/Update/update.txt $+(HTTP/1.0,$crlf,User-Agent:) $+(WaTech,$crlf,Accept:) $+(/*,$crlf,Host:) %upd8_m
    sockwrite -n $sockname $crlf
    sockwrite -n $sockname Connection: Close
  }
}
on *:dialog:update:close:*:{
  if ($hget(version)) hfree version
  if ($hget(file)) hfree file
  unset %version %dx*
  sockclose upd8*
}
alias upd8r dialog $iif($dialog(upd8r),-v,-mh) upd8r upd8r
dialog upd8r {
  title "Update In Progress"
  size 520 520 120 30
  option dbu
  icon imgs\1x.ico
  text "", 1, 5 19 110 9
  text "", 2, 4 4 112 10
}
alias updateme {
  if ($hget(soulfly,upd8x)) hdel soulfly upd8x
  if ($hget(version)) hfree version
  .unset %version %dx*
  hmake version 40
  if ($dialog(update)) dialog -x update update
  if ($1 = x) hadd soulfly upd8x $true
  var %u = $ini(soulfly.ini,version,0)
  while (%u) {
    if ($ini(soulfly.ini,version,%u)) {
      %version = $addtok(%version,$ifmatch,32)
      hadd version $ifmatch $readini(soulfly.ini,version,$ifmatch)
    }
    dec %u
  }
  .signal upd8 www.washington-tech.com 80 $hget(version,0).item
}
